package
{
	import mx.controls.*;
	import flash.display.*;
	import flash.utils.ByteArray;
	import flash.geom.*;
	import mx.events.EffectEvent;
	import mx.containers.Canvas;
	import mx.events.IndexChangedEvent;
	import flash.net.URLStream;
	import flash.net.URLRequest;
	import flash.events.*;
            
	public class ImgHandler
	{
		private var Buffer:Array;
		private var myXML:XML;
		private var parentContainer:DisplayObject;
		private var currentpagestepper:NumericStepper;
		private var parentCanvas:Canvas;
		private var seedstring:String;
		private var artid:String;
		private var sessionid:String;
		private var getContentXmlPhp:String;
		private var curZoom:Number = 1;
		
		//----------------------------------------------------
		//
		//----------------------------------------------------
		private var urlstream1:URLStream = new URLStream();
		private var urlstream2:URLStream = new URLStream();
		private var imageloader1:Loader = new Loader();
		private var imageloader2:Loader = new Loader();
		private var imgdata1:ByteArray = new ByteArray();
		private var imgdata2:ByteArray = new ByteArray();
		


		public function setXmlSource(xmlsource:XML):void{
			myXML = xmlsource;
		}
		public function setSeedString(seed:String):void{
			seedstring=seed;
		}
		public function setArtId(id:String):void{
			artid=id;
		}
		public function setSessionId(session:String):void{
			sessionid=session;
		}
		
		//----------------------------------------------------
		//                  CONSTRUCTOR
		//----------------------------------------------------
		public function ImgHandler(
				img1:Image, img2:Image,
				prg1:ProgressBar, prg2:ProgressBar,
				sourceXml:XML,
				parent:DisplayObject,
				stepper:NumericStepper,
				parentcanvas:Canvas,
				getcontentphpurl:String
			) {
			// Empty constructor
			myXML = sourceXml;
			parentContainer= parent;
			currentpagestepper = stepper;
			parentCanvas = parentcanvas;
			getContentXmlPhp = getcontentphpurl;
			Buffer = [
				/*
				  0 : [img object]
				  1 : [loaded]
				  2 : [decrypted]
				  3 : [page index]
				  4 : [progressbar]
				  5 : [Internet Stream]
				  6 : [loader]
				  7 : [data buffer]
				  8 : original width
				  9 : original height
				 10 : Encryption Key string
				 11 : Encryption Key byte array
				 12 : last encryption key index
				 */
				[ img1, false, false, 1, prg1, urlstream1, imageloader1, imgdata1 , 0, 0 , "0123456789abcdef0123456789abcdef", null, 0]
				,[ img2, false, false, 2, prg2, urlstream2, imageloader2, imgdata2 , 0, 0, "0123456789abcdef0123456789abcdef", null, 0]
			];
			
			//
			urlstream1.addEventListener(Event.COMPLETE, imgloadComplete1);
			urlstream1.addEventListener(ProgressEvent.PROGRESS, imgdownloadprogress1);
			urlstream2.addEventListener(Event.COMPLETE, imgloadComplete2);
			urlstream2.addEventListener(ProgressEvent.PROGRESS, imgdownloadprogress2);
			
			imageloader1.contentLoaderInfo.addEventListener(Event.COMPLETE, contentloadcomplete1);
			imageloader2.contentLoaderInfo.addEventListener(Event.COMPLETE, contentloadcomplete2);
		}
		//........................................ End of function
		
		

		//----------------------------------------------------
		// Find and return array information for given 'page' (1~n) index
		// this returns 'null' if it can not find any matching array
		//----------------------------------------------------
		private function getArrayForPage(page:Number):Array
		{
			var i:int=0;
			for(i=0;i<Buffer.length;i++)
			{
				if(Buffer[i][3] == page)
					return Buffer[i];
			}
			return null;
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		// Returns any first 'blank page' (which is not registered in the 'buffer' array)
		// array information found. (This does not return 'null')
		//----------------------------------------------------
		private function getArrayOfAnyBlankPage(page:Number):Array
		{
			var i:int=0;
			for(i=0;i<Buffer.length;i++)
			{
				if(Buffer[i][3] != page && Buffer[i][3] != currentpagestepper.value){
					return Buffer[i];
				}
			}
			return Buffer[0];
		}
		//........................................ End of function
		
		
		
		//----------------------------------------------------
		// Returns 'Image' object which matches the given 'Page' index (0~n)
		// This returns 'null' when there is no match
		//----------------------------------------------------
		private function getPageImage(page:Number):Image{
			var result:Array = getArrayForPage(page);
			if( result != null )
			{
				return result[0];
			}
			return null;
		}
		//........................................ End of function
		
		
		
		//----------------------------------------------------
		// Returns the 'image' object of the 'currently viewed' or 'about to be shown' page.
		// This returns 'null' when there is no such 'currently (have to be)active' page.
		//----------------------------------------------------
		public function getActiveImage():Image{
			return getPageImage( currentpagestepper.value );
		}
		//........................................ End of function
		
           
        
		
		
		//----------------------------------------------------
		// Shows the given 'page' (index 0~n), and hides the other pages...
		// This saves the given 'page' index information to the 'Buffer' array
		// explaining which Image object is actually showing which 'page'
		//----------------------------------------------------
		private function activateNshowPage(page:Number):void{
			for(var i:int=0;i<Buffer.length	;i++)
			{
				if(Buffer[i][3] == page){ // Page to show
					Buffer[i][0].visible = true;
				}
				else{ // Pages to hide
					Buffer[i][0].visible = false;
				}
			}
		}
		//........................................ End of function
		
		
		private function imgloadComplete1(a:Event):void 
		{
			var progressbar:ProgressBar = Buffer[0][4] as ProgressBar;
			progressbar.setProgress(0,100);
			onImgloadComplete(a, Buffer[0][0] as Image);
		}
		//private var logmsg:String="";
		private function imgdownloadprogress1(a:ProgressEvent):void 
		{
			//var stream:URLStream = Buffer[0][5] as URLStream;
			//logmsg = logmsg + stream.bytesAvailable + "\n";
			Ondownloadprogress(a, 0);
		}
		
		
		private function imgloadComplete2(a:Event):void 
		{
			var progressbar:ProgressBar = Buffer[1][4] as ProgressBar;
			progressbar.setProgress(0,100);
			onImgloadComplete(a, Buffer[1][0] as Image);
		}
		private function imgdownloadprogress2(a:ProgressEvent):void 
		{
			Ondownloadprogress(a, 1);
		}
		
		
		//----------------------------------------------------
		// Check whether the content of given buffer is
		// 'Porgressive Jpeg' or not.
		// (This is working properly... 2007-06-14 brucewang)
		//----------------------------------------------------
		private function isthisProgressiveJpg(buffer:ByteArray):Boolean
		{
			var progressivejpeg:Boolean=false;		
			// Start of frame progressive mode (FFC2)
			// Jpeg header ff d8 ff e0 00 10 4a 46 49
			var limit:uint = buffer.bytesAvailable;
			var n:uint = 0;
			if( limit>10 &&
				buffer[0] == 0xff &&
				buffer[1] == 0xd8 &&
				buffer[2] == 0xff &&
				buffer[3] == 0xe0 &&
				buffer[4] == 0x00 &&
				buffer[5] == 0x10 &&
				buffer[6] == 0x4a &&
				buffer[7] == 0x46 &&
				buffer[8] == 0x49 &&
				buffer[9] == 0x46 )
			{// This is Jpeg data..
				for(n=0; n<limit; n++)
				{
					if( buffer[n] == 0xff && n+1<limit )
					{
						// This means the 'Start of frame progressive mode' (FFC2)
						if( buffer[n+1] == 0xc2 )
						{
							progressivejpeg = true;
							break;
						}
					}
				}
			}			
			return progressivejpeg;
		}
		

		//----------------------------------------------------
		// When the image data downloading is completed...
		// Set array information that the 'target' image is loaded...
		// And if this newly loaded page is the page we need to show right away (active page)
		// then show that page...
		//----------------------------------------------------
		public function onImgloadComplete(a:Event, target:Image):void  
		{
			var i:int = 0;
			// Find the target object array
			for(i=0;i<Buffer.length;i++)
			{
				if( Buffer[i][0] == target )
				{ // Found..
					var imageloader:Loader = Buffer[i][6] as Loader;
					var imgstream:URLStream = Buffer[i][5] as URLStream;
					//var imagedataarray:ByteArray = new ByteArray();				
					//imgstream.readBytes(imagedataarray);
					//imageloader.loadBytes(imagedataarray);					
					var datachunk:ByteArray = Buffer[i][7] as ByteArray;
					
					
					
					//################################################
					//
					// DATA DECRYPTION AFTER DOWNLOAD COMPLETION
					//
					//################################################
					/*
					// For just normal (Non-Progressive) image...
					 */
					datachunk.position=0;
					if(datachunk.bytesAvailable<1 )
					{
						trace("Zero data");
						break;
					}
					imageloader.loadBytes(datachunk);		
					//imageloader.mask = this.parentContainer;
					target.addChild(imageloader);
					//################################################

					//Set it is loaded.
					Buffer[i][1] = true;
					if(Buffer[i][3] == currentpagestepper.value){ // Active Page (current page to show)??
						activateNshowPage(currentpagestepper.value);//i+1);
					}
					
					break;
				}
			}
			
			/********************************************
			// Smoothing image....
			var bitmap:Bitmap = target.content as Bitmap;
			bitmap.smoothing = true;
			//*******************************************/
		}//........................................ End of function
		
		
		
		//----------------------------------------------------	
		//
		//----------------------------------------------------	
		private function Ondownloadprogress(event:ProgressEvent, index:int):void
		{
			var progressbar:ProgressBar = Buffer[index][4] as ProgressBar;
			var imgstream:URLStream = Buffer[index][5] as URLStream;
			var targetbuffer:ByteArray = Buffer[index][7] as ByteArray;
			var keyarray:ByteArray = Buffer[index][11] as ByteArray;
			
			var oldDatacunkPosition:uint = targetbuffer.bytesAvailable;
			imgstream.readBytes( targetbuffer, oldDatacunkPosition );
			var newDatacunkLength:uint = targetbuffer.length;
			
			
			progressbar.setProgress(event.bytesLoaded, event.bytesTotal);
			//trace("loaded/total : " + event.bytesLoaded + "/" + event.bytesTotal );
			
			
			//################################################
			//
			//        SIMULTANEOUS DATA DECRYPTION
			//
			var keylength:int = Buffer[index][10].length;
			var ikeyiteration:int=Buffer[index][12];
			var temp:uint=0;
			for(var j:uint = oldDatacunkPosition; j<newDatacunkLength; j++)
			{
				temp = targetbuffer[j];
				targetbuffer[j] ^= keyarray[ikeyiteration];//enckey[ikeyiteration];
				keyarray[ikeyiteration] = temp;//enckey[ikeyiteration] = temp;
				ikeyiteration++; //!!
				if(ikeyiteration>=keylength) ikeyiteration=0;
				Buffer[index][12] = ikeyiteration;
			}
			//################################################
			
			
			/**************************************************
			 * For Progressive Jpeg
			 * 
			//
			//trace( isthisProgressiveJpg(targetbuffer).toString() );
			//
			var imageloader:Loader = Buffer[index][6] as Loader;
			var target:Image = Buffer[index][0] as Image;
			targetbuffer.position = 0;
			imageloader.loadBytes(targetbuffer);		
			target.addChild(imageloader);		
			if(Buffer[index][3] == currentpagestepper.value){ 
				activateNshowPage(currentpagestepper.value);
				//Set it is loaded.
				Buffer[index][1] = true;
			}
			/***************************************************/
			
		}//........................................ End of function
		
		
		
		
		//----------------------------------------------------	
		// Loads image for a given 'Page' (index 0~n) to any availabe Image object,
		// And this also preloads another page image for faster downloading.
		//----------------------------------------------------
		public function preloadPage(page:Number, forward:Boolean):void{
			loadPage(page,true);
			if(forward) loadPage(page+1,false);
			else loadPage(page-1,false);
		}
		//........................................ End of function


		//----------------------------------------------------
		// ....
		//----------------------------------------------------
		private function generateModifiedKey(originalkey:String, seed:String):String
		{
			var keymod:String="";
			var keytable:Array = new Array( 
				'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
				'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
				'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
				'u', 'v', 'w', 'x', 'y', 'z' );
			
			var keylen:int = originalkey.length;
			var numkey:int=0;
			var numseed:int=0;
			var nummod:int=0;
			
			for(var i:int=0; i<keylen; i++)
			{
				for(var j:int=0; j<keytable.length; j++)
				{
					if( originalkey.charAt(i) == keytable[j] )
					//if( originalkey[i] == keytable[j] )
					{
						numkey  = j;
						break;
					}
				}
				for(var k:int=0; k<keytable.length; k++)
				{
					if( seed.charAt(i) == keytable[k] )
					//if( seed[i] == keytable[k] )
					{
						numseed  = k;
						break;
					}
				}
				nummod = numkey-numseed;
				keymod = keymod + keytable[nummod];
			}
			
			return keymod;
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		// Loads image for a given 'Page' (index 0~n) to any availabe Image object
		// If the given page image is already loaded before, this can show it and activate it
		// if needed (for the Active page to show, not for 'preload' images). 
		//----------------------------------------------------
		private function loadPage(page:Number, bShowAlreadyLoadedPage:Boolean):void
		{
			if( myXML != null && myXML.item.length() > 0 &&
				page>=1 &&
				page<=myXML.item.length())
			{
				//var curpageimage:Image = getPageImage(page);
				var curimgstream:URLStream = null;
				var curpagearray:Array = getArrayForPage(page);
				if( curpagearray == null )
				{
					curpagearray = getArrayOfAnyBlankPage(page);
					curpagearray[1] = false; // SET as 'NOT LOADED'...
					curpagearray[3] = page; // SET PAGE INDEX
					//curpageimage = curpagearray[0];
				}
				
				//var nextpagearay:Array = getArrayForPage(page+1);
				
				/// Load current page
				if( curpagearray[1] == true && curpagearray[3] == page )
				{//loaded
					if(bShowAlreadyLoadedPage)
					{
						activateNshowPage(page);
						return;
					}
				}
				
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				// Find proper encryption key string
				var encKeyString:String = myXML.item[page-1].key;
				curpagearray[10] = generateModifiedKey(encKeyString, this.seedstring);
				//
				curpagearray[11] = new ByteArray();// (keylength);
				curpagearray[11].writeUTFBytes(curpagearray[10]);
				curpagearray[11].position = 0;
				curpagearray[12] = 0;
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			
				var imgurl:String=
					getContentXmlPhp + "?PHPSESSID=" +
					sessionid + "&artid=" + artid + 
					"&page="+ String(page-1) +
					"&mode=image";
				
				{
					curpagearray[1] = false; // Not loaded
					curimgstream = curpagearray[5] as URLStream;
					var chunk:ByteArray = curpagearray[7] as ByteArray;
					chunk.position=0;
					chunk.length=0;
					curimgstream.load( new URLRequest(imgurl) );
				}
			}// end of 'if'
		}
		//........................................ End of function
		
		
		
		
		
		
		//####################################################
		//####################################################
		//####################################################
		


		
				
		//----------------------------------------------------
		// ....
		//----------------------------------------------------
		public function onZoomChanged(zoom:Number):void
		{
			curZoom = zoom/100;
			for(var i:int=0;i<Buffer.length	;i++)
			{
				var img:Image = Buffer[i][0] as Image;
				img.scaleX = curZoom;
				img.scaleY = curZoom;

				//img.width = Buffer[i][8] * curZoom;//img.scaleX;
				//img.height= Buffer[i][9] * curZoom;//img.scaleY;
				//img.x=0;
				//img.y=0;
			}
			//onCanvasResize();
		}
		//........................................ End of function
		
		//----------------------------------------------------
        // ......
        //----------------------------------------------------   
		public function onCanvasResize():void
		{
			for(var i:int=0;i<Buffer.length	;i++)
			{
				var img:Image = Buffer[i][0];
				onResizeImage(img);
			}
		}
		//........................................ End of function


		//----------------------------------------------------
		//
		//
		//----------------------------------------------------
		public function onResizeImage(img:Image):void{
			//if(img.visible==false) return;
			var w:int = img.width*curZoom;
			var h:int = img.height*curZoom;
			img.x = ( parentCanvas.width- w )/2;
			img.y = ( parentCanvas.height- h )/2;
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		//
		//
		//----------------------------------------------------
		private function contentloadcomplete1(a:Event):void 
		{
			var target:Image = Buffer[0][0] as Image;
			var loader:Loader= Buffer[0][6] as Loader;
			target.width = loader.contentLoaderInfo.width;// * curZoom;
			target.height = loader.contentLoaderInfo.height;// * curZoom;
			target.scaleX = curZoom;
			target.scaleY = curZoom;
			Buffer[0][8] = loader.contentLoaderInfo.width;
			Buffer[0][9] = loader.contentLoaderInfo.height;
			/* trace("NewContentSize(w/h):" + 
				loader.contentLoaderInfo.width + "/" +
				loader.contentLoaderInfo.height +
				"(Zoom:"+ curZoom*100 + "%)" ); */
		}//........................................ End of function
		
		//----------------------------------------------------
		//
		//
		//----------------------------------------------------
		private function contentloadcomplete2(a:Event):void 
		{
			var target:Image = Buffer[1][0] as Image;
			var loader:Loader= Buffer[1][6] as Loader;
			target.width = loader.contentLoaderInfo.width;// * curZoom;
			target.height = loader.contentLoaderInfo.height;// * curZoom;
			target.scaleX = curZoom;
			target.scaleY = curZoom;
			Buffer[1][8] = loader.contentLoaderInfo.width;
			Buffer[1][9] = loader.contentLoaderInfo.height;
			/* trace("NewContentSize(w/h):" + 
				loader.contentLoaderInfo.width + "/" +
				loader.contentLoaderInfo.height +
				"(Zoom:"+ curZoom*100 + "%)" ); */
		}//........................................ End of function
		
		//----------------------------------------------------
		// 2007-05-06 brucewang
		//    Scroll image w.r.t the current mouse position.
		//----------------------------------------------------
		public function ScrollImage():void 
		{
			if(getActiveImage()==null) return;
			
			var curImage:Image = getActiveImage();
			//curImage.visible = true;
			
			var curpagearray:Array = getArrayForPage( currentpagestepper.value );
			
			var xvector:int = 0;
			var yvector:int = 0;
			var xmaxfactor:int = 32;
			var ymaxfactor:int = 32;
			var mousex:int = parentCanvas.mouseX;
			var mousey:int = parentCanvas.mouseY;
			var parentWidth:int = parentCanvas.width;
			var parentHeight:int = parentCanvas.height;
			//
			var imgwidth:int = 
				curpagearray[8] * curZoom;
				//curImage.width * this.curZoom;
			var imgheight:int = 
				curpagearray[9] * curZoom;
				//curImage.height * this.curZoom;
			//
			
			if( imgwidth<=parentWidth && imgheight<=parentHeight )
			{
				curImage.x = (parentWidth-imgwidth)/2;
				curImage.y = (parentHeight-imgheight)/2;
				return;
			}
			
			/// Scroll only when the mouse pointer is inside the
			/// canvas...
			if( parentCanvas.getBounds(parentContainer).containsPoint(
				new Point(mousex,mousey)) == false )
				return;
			
			// Calculate move vector.
			if( parentWidth/2 < mousex ){
				xvector = -1;
				xvector = xmaxfactor * xvector * (mousex - parentWidth/2)/(parentWidth/2);
			}
			else{
				xvector = 1;
				xvector = xmaxfactor * xvector * (parentWidth/2 - mousex)/(parentWidth/2);
			}
			if( parentHeight/2 < mousey ){
				yvector = -1;
				yvector = ymaxfactor * yvector * (mousey - parentHeight/2)/(parentHeight/2);
			}
			else{
				yvector = 1;
				yvector = ymaxfactor * yvector * (parentHeight/2 - mousey)/(parentHeight/2);
			}
			
			var oldx:int = curImage.x;
			var oldy:int = curImage.y;
			var newx:int = oldx + xvector;
			var newy:int = oldy + yvector;
			
			//
			// Confinding the scroll area
			//
			if( parentWidth <= imgwidth ){
				if( newx > 0 )  
					newx = 0;
				else if ( newx < (parentWidth-imgwidth) )//newx < (parentWidth-imgwidth)/2 )
					newx = (parentWidth - imgwidth);// /2;
			}
			else{
				newx = (parentWidth - imgwidth)/2;
			}
			
			if( parentHeight <= imgheight ){
				if( newy > 0 ) 
					newy = 0;
				else if ( newy < (parentHeight - imgheight) )//newy < (parentHeight - imgheight)/2 )
					newy = (parentHeight - imgheight);// /2;
			}
			else{
				newy = (parentHeight - imgheight)/2;
			}
			
			if( newx!=oldx) curImage.x = newx;
			if( newy!=oldy) curImage.y = newy;
		}
		//........................................ End of function

	}// End of CLASS
}