package
{
	import mx.controls.*;
	import flash.display.*;
	import flash.utils.ByteArray;
	import flash.geom.*;
	import mx.events.EffectEvent;
	import mx.containers.Canvas;
	import mx.events.IndexChangedEvent;
	import flash.net.URLStream;
	import flash.net.URLRequest;
	import flash.events.*;
            
	public class ImgHandler
	{
		private var Buffer:Array = new Array();
		private var myXML:XML;
		private var parentContainer:DisplayObject;
		private var currentpagestepper:NumericStepper;
		private var parentCanvas:Canvas;
		private var seedstring:String;
		private var artid:String;
		private var sessionid:String;
		private var getContentXmlPhp:String;
		private var curZoom:Number = 1;
		private var PageShowPending:int = 0;
		
		//----------------------------------------------------
		//
		//----------------------------------------------------
		private var urlstream1:URLStream = new URLStream();
		private var imageloader1:Loader = new Loader();
		private var tmpimg:Image = null;
		private var curDownloadPage:int = 0;
		private var recentlyLoadedPage:int = 0;
		private var progress:ProgressBar = null;
		


		
		//----------------------------------------------------
		//                  CONSTRUCTOR
		//----------------------------------------------------
		public function ImgHandler(
				img1:Image, img2:Image,
				prg1:ProgressBar, prg2:ProgressBar,
				sourceXml:XML,
				parent:DisplayObject,
				stepper:NumericStepper,
				parentcanvas:Canvas,
				getcontentphpurl:String
			) {
			// Empty constructor
			myXML = sourceXml;
			parentContainer= parent;
			currentpagestepper = stepper;
			parentCanvas = parentcanvas;
			getContentXmlPhp = getcontentphpurl;
			
			
			tmpimg = img1;
			progress = prg1;


			//
			urlstream1.addEventListener(Event.COMPLETE, imgloadComplete1);
			urlstream1.addEventListener(ProgressEvent.PROGRESS, imgdownloadprogress1);
			imageloader1.contentLoaderInfo.addEventListener(Event.COMPLETE, contentloadcomplete1);
		}
		//........................................ End of function
		
		
		
		//----------------------------------------------------
		//
		//----------------------------------------------------
		public function setXmlSource(xmlsource:XML):void{
			myXML = xmlsource;
			var numPages:int = myXML.item.length();
			var i:int = 0;
			var encKeyString:String = "";
			var offset:uint=0;
			for ( i=0; i<numPages; i++ )
			{
				/********
				 *  0 : Image
				 *  1 : Page
				 *  2 : Data offset
				 *  3 : data size
				 *  4 : completed
				 *  5 : width
				 *  6 : height
				 *  7 : keystring
				 *  8 : keybyte
				 *  9 : last encryption key index
				 * 10 : image data
				 ******** */
				Buffer[i] = [tmpimg, 0, 0, int(myXML.item[i].size) , false, 0, 0, "", null, 0, new ByteArray()];
				
				if( i>0 )
				{
					Buffer[i][2] = offset;
				}
				offset = offset + int(myXML.item[i].size);
				
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				// Find proper encryption key string
				encKeyString = myXML.item[i].key;
				Buffer[i][7] = generateModifiedKey(encKeyString, this.seedstring);
				Buffer[i][8] = new ByteArray();// (keylength);
				Buffer[i][8].writeUTFBytes(Buffer[i][7]);
				Buffer[i][8].position = 0;
				Buffer[i][9] = 0;
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			}
			
			//
			var imgurl:String=
				getContentXmlPhp + "?PHPSESSID=" +
				sessionid + "&artid=" + artid + 
				"&page="+ String(0) +
				"&mode=image";
			{
				urlstream1.load( new URLRequest(imgurl) );
			}
		}
		public function setSeedString(seed:String):void{
			seedstring=seed;
		}
		public function setArtId(id:String):void{
			artid=id;
		}
		public function setSessionId(session:String):void{
			sessionid=session;
		}
		

		
		//----------------------------------------------------
		// 
		//----------------------------------------------------
		private function imgloadComplete1(a:Event):void 
		{
			//var progressbar:ProgressBar = Buffer[0][4] as ProgressBar;
			//progressbar.setProgress(0,100);
			onImgloadComplete(a, Buffer[0][0] as Image);
		}
		//private var logmsg:String="";
		private function imgdownloadprogress1(a:ProgressEvent):void 
		{
			//var stream:URLStream = Buffer[0][5] as URLStream;
			//logmsg = logmsg + stream.bytesAvailable + "\n";
			Ondownloadprogress(a, 0);
		}
		
		/************************************************************
		private function imgloadComplete2(a:Event):void 
		{
			var progressbar:ProgressBar = Buffer[1][4] as ProgressBar;
			progressbar.setProgress(0,100);
			onImgloadComplete(a, Buffer[1][0] as Image);
		}
		private function imgdownloadprogress2(a:ProgressEvent):void 
		{
			Ondownloadprogress(a, 1); 
		}
		***********************************************************/
		
		//----------------------------------------------------
		// Shows the given 'page' (index 0~n), and hides the other pages...
		// This saves the given 'page' index information to the 'Buffer' array
		// explaining which Image object is actually showing which 'page'
		//----------------------------------------------------
		private function activateNshowPage(page:Number):void{
			/********
			 * 0 : Image
			 * 1 : Page
			 * 2 : Data offset
			 * 3 : data size
			 * 4 : completed
			 * 5 : width
			 * 6 : height
			 * 7 : keystring
			 * 8 : keybyte
			 * 9 : last encryption key index
			 ******** */
			 tmpimg.visible = true;
			/*****
			for(var i:int=0;i<Buffer.length	;i++)
			{
				if(Buffer[i][3] == page){ // Page to show
					Buffer[i][0].visible = true;
				}
				else{ // Pages to hide
					Buffer[i][0].visible = false;
				}
			}
			 * *****/
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		// When the image data downloading is completed...
		// Set array information that the 'target' image is loaded...
		// And if this newly loaded page is the page we need to show right away (active page)
		// then show that page...
		//----------------------------------------------------
		public function onImgloadComplete(a:Event, target:Image):void  
		{
			//progress.setProgress(0, 100);
			OnPageComplete(1);
		}//........................................ End of function
		
		//----------------------------------------------------	
		//
		//----------------------------------------------------	
		private function OnPageComplete(page:int):void
		{
			// If not completed...
			if( Buffer[page-1][4] == false)
				return;
				
			if(page != currentpagestepper.value)
				return;
				
			// PageShowPending
			/********
			 * 0 : Image
			 * 1 : Page
			 * 2 : Data offset
			 * 3 : data size
			 * 4 : completed
			 * 5 : width
			 * 6 : height
			 * 7 : keystring
			 * 8 : keybyte
			 * 9 : last encryption key index
			 ******** */
			var imageloader:Loader = imageloader1;
			var datachunk:ByteArray = Buffer[page-1][10] as ByteArray;
			
			//################################################
			//
			// DATA DECRYPTION AFTER DOWNLOAD COMPLETION
			//
			//################################################
			/*
			// For just normal (Non-Progressive) image...
			 */
			//datachunk.position=Buffer[page-1][2];
			if(datachunk.bytesAvailable<1 )
			{
				trace("Zero data");
				return;
			}
			recentlyLoadedPage = page;
			imageloader.loadBytes(datachunk);		
			//trace( "Load bytes from : " + datachunk.position );
			//imageloader.mask = this.parentContainer;
			tmpimg.addChild(imageloader);
			//################################################

			//if(Buffer[i][3] == currentpagestepper.value)
			{ // Active Page (current page to show)??
				activateNshowPage(currentpagestepper.value);//i+1);
			}
		}
		
		//----------------------------------------------------
		// !!!!!!!!!!!
		//
		//----------------------------------------------------
		private function contentloadcomplete1(a:Event):void 
		{
			var index:int = recentlyLoadedPage - 1;
			/********
			 * 0 : Image
			 * 1 : Page
			 * 2 : Data offset
			 * 3 : data size
			 * 4 : completed
			 * 5 : width
			 * 6 : height
			 * 7 : keystring
			 * 8 : keybyte
			 * 9 : last encryption key index
			 ******** */
			var target:Image = Buffer[index][0] as Image;
			var loader:Loader= this.imageloader1;//Buffer[0][6] as Loader;
			target.width = loader.contentLoaderInfo.width;// * curZoom;
			target.height = loader.contentLoaderInfo.height;// * curZoom;
			target.scaleX = curZoom;
			target.scaleY = curZoom;
			Buffer[index][5] = loader.contentLoaderInfo.width;
			Buffer[index][6] = loader.contentLoaderInfo.height;
			
			
			centerImage(target);
		}//........................................ End of function

		
		
		//----------------------------------------------------	
		//
		//----------------------------------------------------	
		private function Ondownloadprogress(event:ProgressEvent, index:int):void
		{
			/********
			 * 0 : Image
			 * 1 : Page
			 * 2 : Data offset
			 * 3 : data size
			 * 4 : completed
			 * 5 : width
			 * 6 : height
			 * 7 : keystring
			 * 8 : keybyte
			 * 9 : last encryption key index
			 ******** */
			var keyarray:ByteArray = Buffer[curDownloadPage][8] as ByteArray;
			var imgstream:URLStream = urlstream1;
			var targetbuffer:ByteArray = Buffer[curDownloadPage][10] as ByteArray;
			
			
			if( imgstream.bytesAvailable == 0 ) return;
			
			
			progress.setProgress(event.bytesLoaded, event.bytesTotal);

			/**********
			**********/
			var oldDatacunkPosition:uint = targetbuffer.bytesAvailable;
			var filesize:uint = Buffer[curDownloadPage][3];
			var datalengthtoread:uint = filesize - oldDatacunkPosition;
			var bPrepareNextBuffer:Boolean = false;
			//trace( "data to read : " + datalengthtoread + ", bytes available : " + imgstream.bytesAvailable);
			
			if( datalengthtoread > imgstream.bytesAvailable)
				datalengthtoread = imgstream.bytesAvailable;
			else
			{
				bPrepareNextBuffer = true;
			}
			

			imgstream.readBytes( targetbuffer, oldDatacunkPosition, datalengthtoread);
			
			
			//################################################
			//
			//        SIMULTANEOUS DATA DECRYPTION
			//
			var keylength:int = keyarray.length;
			var ikeyiteration:int=Buffer[curDownloadPage][9];
			var temp:uint=0;
			for(var j:uint = oldDatacunkPosition; 
				j<datalengthtoread+oldDatacunkPosition; 
				j++)
			{
				temp = targetbuffer[j];
				targetbuffer[j] ^= keyarray[ikeyiteration];//enckey[ikeyiteration];
				keyarray[ikeyiteration] = temp;//enckey[ikeyiteration] = temp;
				ikeyiteration++; //!!
				if(ikeyiteration>=keylength) ikeyiteration=0;
				Buffer[curDownloadPage][9] = ikeyiteration;
			}
			//################################################
			
			

			if(bPrepareNextBuffer==true)
			{
				Buffer[curDownloadPage][4] = true; // Set completed
				curDownloadPage = curDownloadPage+1;
				OnPageComplete(curDownloadPage);
			}
			
			
			
			/**************************************************
			 * For Progressive Jpeg
			 * 
			//
			//trace( isthisProgressiveJpg(targetbuffer).toString() );
			//
			var imageloader:Loader = Buffer[index][6] as Loader;
			var target:Image = Buffer[index][0] as Image;
			targetbuffer.position = 0;
			imageloader.loadBytes(targetbuffer);		
			target.addChild(imageloader);		
			if(Buffer[index][3] == currentpagestepper.value){ 
				activateNshowPage(currentpagestepper.value);
				//Set it is loaded.
				Buffer[index][1] = true;
			}
			/***************************************************/
			
		}//........................................ End of function
		
		
		//----------------------------------------------------
		// Check whether the content of given buffer is
		// 'Porgressive Jpeg' or not.
		// (This is working properly... 2007-06-14 brucewang)
		//----------------------------------------------------
		private function isthisProgressiveJpg(buffer:ByteArray):Boolean
		{
			var progressivejpeg:Boolean=false;		
			// Start of frame progressive mode (FFC2)
			// Jpeg header ff d8 ff e0 00 10 4a 46 49
			var limit:uint = buffer.bytesAvailable;
			var n:uint = 0;
			if( limit>10 &&
				buffer[0] == 0xff &&
				buffer[1] == 0xd8 &&
				buffer[2] == 0xff &&
				buffer[3] == 0xe0 &&
				buffer[4] == 0x00 &&
				buffer[5] == 0x10 &&
				buffer[6] == 0x4a &&
				buffer[7] == 0x46 &&
				buffer[8] == 0x49 &&
				buffer[9] == 0x46 )
			{// This is Jpeg data..
				for(n=0; n<limit; n++)
				{
					if( buffer[n] == 0xff && n+1<limit )
					{
						// This means the 'Start of frame progressive mode' (FFC2)
						if( buffer[n+1] == 0xc2 )
						{
							progressivejpeg = true;
							break;
						}
					}
				}
			}			
			return progressivejpeg;
		}

		
		//----------------------------------------------------	
		// Loads image for a given 'Page' (index 0~n) to any availabe Image object,
		// And this also preloads another page image for faster downloading.
		//----------------------------------------------------
		public function preloadPage(page:Number, forward:Boolean):void{
			loadPage(page,true);
			//if(forward) loadPage(page+1,false);
			//else loadPage(page-1,false);
		}
		//........................................ End of function


		//----------------------------------------------------
		// ....
		//----------------------------------------------------
		private function generateModifiedKey(originalkey:String, seed:String):String
		{
			var keymod:String="";
			var keytable:Array = new Array( 
				'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
				'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
				'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
				'u', 'v', 'w', 'x', 'y', 'z' );
			
			var keylen:int = originalkey.length;
			var numkey:int=0;
			var numseed:int=0;
			var nummod:int=0;
			
			for(var i:int=0; i<keylen; i++)
			{
				for(var j:int=0; j<keytable.length; j++)
				{
					if( originalkey.charAt(i) == keytable[j] )
					//if( originalkey[i] == keytable[j] )
					{
						numkey  = j;
						break;
					}
				}
				for(var k:int=0; k<keytable.length; k++)
				{
					if( seed.charAt(i) == keytable[k] )
					//if( seed[i] == keytable[k] )
					{
						numseed  = k;
						break;
					}
				}
				nummod = numkey-numseed;
				keymod = keymod + keytable[nummod];
			}
			
			return keymod;
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		// Loads image for a given 'Page' (index 0~n) to any availabe Image object
		// If the given page image is already loaded before, this can show it and activate it
		// if needed (for the Active page to show, not for 'preload' images). 
		//----------------------------------------------------
		private function loadPage(page:Number, bShowAlreadyLoadedPage:Boolean):void
		{
			if( myXML != null && myXML.item.length() > 0 &&
				page>=1 &&
				page<=myXML.item.length())
			{
				/********
				 * 0 : Image
				 * 1 : Page
				 * 2 : Data offset
				 * 3 : data size
				 * 4 : completed
				 ******** */
				if( Buffer[page-1][4] == false )
				{
					PageShowPending = int(page-1);
				}
				else
				{
					OnPageComplete(page);
				}
			}// end of 'if'..
		}
		//........................................ End of function
		
		
		
		
		
		
		//####################################################
		//####################################################
		//####################################################
		


		
				
		//----------------------------------------------------
		// ....
		//----------------------------------------------------
		public function onZoomChanged(zoom:Number):void
		{
			curZoom = zoom/100;
			for(var i:int=0;i<Buffer.length	;i++)
			{
				var img:Image = Buffer[i][0] as Image;
				img.scaleX = curZoom;
				img.scaleY = curZoom;
			}
		}
		//........................................ End of function
		
		//----------------------------------------------------
        // ......
        //----------------------------------------------------   
		public function onCanvasResize():void
		{
			for(var i:int=0;i<Buffer.length	;i++)
			{
				var img:Image = Buffer[i][0];
				centerImage(img);
			}
		}
		//........................................ End of function
		
		
		//----------------------------------------------------
		//
		//
		//----------------------------------------------------
		private function centerImage(img:Image):void
		{
			//if(img.visible==false) return;
			var w:int = img.width*curZoom;
			var h:int = img.height*curZoom;
			img.x = ( parentCanvas.width- w )/2;
			img.y = ( parentCanvas.height- h )/2;
		}


		//----------------------------------------------------
		//
		//
		//----------------------------------------------------
		public function onResizeImage(img:Image):void{
			
		}
		//........................................ End of function
		
		
		
		
		//----------------------------------------------------
		// 2007-05-06 brucewang
		//    Scroll image w.r.t the current mouse position.
		//----------------------------------------------------
		public function ScrollImage():void 
		{
			if(getActiveImage()==null) return;
			
			var curImage:Image = getActiveImage();
			//curImage.visible = true;
			
			var curpagearray:Array = getArrayForPage( currentpagestepper.value );
			if( curpagearray == null ) return;
			
			var xvector:int = 0;
			var yvector:int = 0;
			var xmaxfactor:int = 32;
			var ymaxfactor:int = 32;
			var mousex:int = parentCanvas.mouseX;
			var mousey:int = parentCanvas.mouseY;
			var parentWidth:int = parentCanvas.width;
			var parentHeight:int = parentCanvas.height;
			//
			/********
			 *  0 : Image
			 *  1 : Page
			 *  2 : Data offset
			 *  3 : data size
			 *  4 : completed
			 *  5 : width
			 *  6 : height
			 *  7 : keystring
			 *  8 : keybyte
			 *  9 : last encryption key index
			 * 10 : image data
			 ******** */
			var imgwidth:int = curpagearray[5] * curZoom;
				//curImage.width * this.curZoom;
			var imgheight:int = curpagearray[6] * curZoom;
				//curImage.height * this.curZoom;
			//
			
			if( imgwidth<=parentWidth && imgheight<=parentHeight )
			{
				curImage.x = (parentWidth-imgwidth)/2;
				curImage.y = (parentHeight-imgheight)/2;
				return;
			}
			
			/// Scroll only when the mouse pointer is inside the
			/// canvas...
			if( parentCanvas.getBounds(parentContainer).containsPoint(
				new Point(mousex,mousey)) == false )
				return;
			
			// Calculate move vector.
			if( parentWidth/2 < mousex ){
				xvector = -1;
				xvector = xmaxfactor * xvector * (mousex - parentWidth/2)/(parentWidth/2);
			}
			else{
				xvector = 1;
				xvector = xmaxfactor * xvector * (parentWidth/2 - mousex)/(parentWidth/2);
			}
			if( parentHeight/2 < mousey ){
				yvector = -1;
				yvector = ymaxfactor * yvector * (mousey - parentHeight/2)/(parentHeight/2);
			}
			else{
				yvector = 1;
				yvector = ymaxfactor * yvector * (parentHeight/2 - mousey)/(parentHeight/2);
			}
			
			var oldx:int = curImage.x;
			var oldy:int = curImage.y;
			var newx:int = oldx + xvector;
			var newy:int = oldy + yvector;
			
			//
			// Confinding the scroll area
			//
			if( parentWidth <= imgwidth ){
				if( newx > 0 )  
					newx = 0;
				else if ( newx < (parentWidth-imgwidth) )//newx < (parentWidth-imgwidth)/2 )
					newx = (parentWidth - imgwidth);// /2;
			}
			else{
				newx = (parentWidth - imgwidth)/2;
			}
			
			if( parentHeight <= imgheight ){
				if( newy > 0 ) 
					newy = 0;
				else if ( newy < (parentHeight - imgheight) )//newy < (parentHeight - imgheight)/2 )
					newy = (parentHeight - imgheight);// /2;
			}
			else{
				newy = (parentHeight - imgheight)/2;
			}
			
			if( newx!=oldx) curImage.x = newx;
			if( newy!=oldy) curImage.y = newy;
		}
		//........................................ End of function




		//----------------------------------------------------
		// Find and return array information for given 'page' (1~n) index
		// this returns 'null' if it can not find any matching array
		//----------------------------------------------------
		private function getArrayForPage(page:Number):Array
		{
			var i:int=0;
			if( Buffer == null ) return null;
			
			if( page>0 && page<=Buffer.length )
			{
				return Buffer[page-1];
			}
			return null;
		}
		//........................................ End of function
		
		
		
		//----------------------------------------------------
		// Returns 'Image' object which matches the given 'Page' index (0~n)
		// This returns 'null' when there is no match
		//----------------------------------------------------
		private function getPageImage(page:Number):Image{
			var result:Array = getArrayForPage(page);
			if( result != null )
			{
				return result[0];
			}
			return null;
		}
		//........................................ End of function
		
		
		
		//----------------------------------------------------
		// Returns the 'image' object of the 'currently viewed' or 'about to be shown' page.
		// This returns 'null' when there is no such 'currently (have to be)active' page.
		//----------------------------------------------------
		public function getActiveImage():Image{
			return getPageImage( currentpagestepper.value );
		}
		//........................................ End of function
		
           
        
		
		
		
	}// End of CLASS
}